Loading...
Searching...
No Matches
casacore::LatticeExpr< T > Class Template Reference
lattices package (libcasa_lattices) » LEL_module

More...

`#include <LatticeExpr.h>`

## Public Member Functions

| LatticeExpr ()
| Default constructor.
| LatticeExpr (const LatticeExprNode &expr)
| Constructor from an arbitrary LatticeExprNode expression object.
| LatticeExpr (const LatticeExprNode &expr, const IPosition &latticeShape)
| LatticeExpr (const LatticeExpr< T > &other)
| Copy constructor (reference semantics).
virtual | ~LatticeExpr ()
| Destructor, does nothing.
LatticeExpr< T > & | operator= (const LatticeExpr< T > &other)
| Assignment (reference semantics).
virtual MaskedLattice< T > * | cloneML () const
| Make a copy of the derived object (reference semantics).
virtual Bool | isMasked () const
| Has the object really a mask?
virtual const LatticeRegion * | getRegionPtr () const
| Get the region used (always returns 0).
virtual Bool | isWritable () const
| Returns False, as the LatticeExpr lattice is not writable.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| Handle locking of the LatticeExpr which is delegated to all of its parts.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual IPosition | shape () const
| Returns the shape of the Lattice including all degenerate axes (i.e.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| Return the best cursor shape.
virtual LELCoordinates | lelCoordinates () const
| Returns the coordinates of the lattice expression.
virtual Bool | doGetSlice (Array< T > &buffer, const Slicer &section)
| Do the actual get of the data.
virtual Bool | doGetMaskSlice (Array< Bool > &buffer, const Slicer &section)
| Do the actual get of the mask data.
virtual void | doPutSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| An expression is not writable so this functions throws an exception.
virtual void | copyDataTo (Lattice< T > &to) const
| Copy the data from this lattice to the given lattice.
virtual void | handleMathTo (Lattice< T > &to, int oper) const
| Handle the Math operators (+=, -=, *=, /=).
void | handleMathTo (Lattice< Bool > &, int) const
Public Member Functions inherited from casacore::MaskedLattice< T >
| MaskedLattice ()
| Default constructor.
| MaskedLattice (const MaskedLattice< T > &)
| Copy constructor.
virtual | ~MaskedLattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual Lattice< T > * | clone () const
| Make a copy of the derived object (reference semantics).
virtual Bool | hasPixelMask () const
| Does the lattice have a pixelmask?
virtual const Lattice< Bool > & | pixelMask () const
| Get access to the pixelmask.
virtual Lattice< Bool > & | pixelMask ()
const LatticeRegion & | region () const
| Get the region used.
Bool | getMask (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Get the mask or a slice from the mask.
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | getMask (Array< Bool > &buffer, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< Bool > | getMask (Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Public Member Functions inherited from casacore::Lattice< T >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
T | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual T | getAt (const IPosition &where) const
virtual void | putAt (const T &value, const IPosition &where)
| Put the value of a single element.
Bool | get (COWPtr< Array< T > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< T > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | get (Array< T > &buffer, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< T > | get (Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where)
void | put (const Array< T > &sourceBuffer)
virtual void | set (const T &value)
| Set all elements in the Lattice to the given value.
virtual void | apply (T(*function)(T))
| Replace every element, x, of the Lattice with the result of f(x).
virtual void | apply (T(*function)(const T &))
virtual void | apply (const Functional< T, T > &function)
void | operator+= (const Lattice< T > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< T > &other)
void | operator*= (const Lattice< T > &other)
void | operator/= (const Lattice< T > &other)
virtual void | copyData (const Lattice< T > &from)
| Copy the data from the given lattice to this one.
virtual uInt | advisedMaxPixels () const
| This function returns the advised maximum number of pixels to include in the cursor of an iterator.
virtual LatticeIterInterface< T > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| These functions are used by the LatticeIterator class to generate an iterator of the correct type for a specified Lattice.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual Bool | isPaged () const
| Is the lattice paged to disk?
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual void | flush ()
| Flush the data (but do not unlock).
virtual void | tempClose ()
| Temporarily close the lattice.
virtual void | reopen ()
| Explicitly reopen the temporarily closed lattice.
virtual String | name (Bool stripPath=False) const
| Return the name of the current Lattice object.
virtual uInt | ndim () const
| Return the number of axes in this Lattice.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual Bool | ok () const
| Check class internals - used for debugging.
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Private Member Functions

void | init (const LatticeExprNode &expr)
| Initialize the object from the expression.

## Private Attributes

LatticeExprNode | expr_p
IPosition | shape_p
LELArray< T > * | lastChunkPtr_p
Slicer | lastSlicer_p

## Additional Inherited Members

Protected Member Functions inherited from casacore::MaskedLattice< T >
MaskedLattice< T > & | operator= (const MaskedLattice< T > &)
| Assignment can only be used by derived classes.
Protected Member Functions inherited from casacore::Lattice< T >
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< T > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
| Lattice (const Lattice< T > &)
| Copy constructor and assignment can only be used by derived classes.
Lattice< T > & | operator= (const Lattice< T > &)
void | handleMathTo (Lattice< Bool > &, int) const
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Detailed Description

template<class T>
class casacore::LatticeExpr< T >

Class to allow C++ expressions involving lattices

### Intended use:

Public interface

### Review Status

Date Reviewed:
  yyyy/mm/dd

### Prerequisite

- Lattice

- LatticeExprNode

### Etymology

The name is derived from the fact that this class provides an expression interface to the user which s/he may use to write C++ expressions involving Lattices.

### Synopsis

This class provides an interface which allows the C++ programmer to enter expressions such as "sin(a)+b" where "a" and "b" are Lattices.

This class is termed an envelope class, and inside it are the letter classes which do the real work. In reality, the letter classes are actually accessed via a bridging class called LatticeExprNode, which exists to handle type conversions. The letter classes iterate through the Lattices and evaluate the expression for each chunk of the iteration (usually a tile shape).

It is in the LatticeExprNode class that all the available expression operations are defined, so you should look there to see what functionality is available.

A description of the implementation details of these classes can be found in Note 216

### Example

ArrayLattice<Float> f1(IPosition (2,nx,ny));
ArrayLattice<Float> f2(IPosition (2,nx,ny));
f2.set(2.0);
f1.copyData(2*f2+f2);
casacore::ArrayLattice
Definition ArrayLattice.h:144
casacore::IPosition
Definition IPosition.h:117

In this example, the values of the pixels in Lattice f1 are set to the values resulting from the expression "2*f2 + f2" I.e. the expression is evaluated for each pixel in the Lattices

Note that : 1) the Lattice::copyData function is expecting a Lattice argument.
2) LatticeExpr inherits from Lattice and therefore a LatticeExpr object is a valid argument object type 3) The expression in the copyData call is automatically converted to a LatticeExprNode by the constructors and operators in LatticeExprNode 4) The LatticeExprNode object so created is automatically converted to a LatticeExpr by casting functions in LatticeExprNode.

### Example

ArrayLattice<Float> f1(IPosition (2,nx,ny));
ArrayLattice<Float> f2(IPosition (2,nx,ny));
ArrayLattice<Double> d(IPosition (2,nx,ny));
ArrayLattice<Complex> c(IPosition (2,nx,ny));
ArrayLattice<Bool> b(IPosition (2,nx,ny));
f2.set(1.0); d.set(2.0); c.set(Complex(2.0,3.0)); b.set(True);
f1.copyData((3.5*f2) + (cos(d)) - (10/min(d,f2)*(-abs(c))*ntrue(b)) - (C::pi));
casacore::C::pi
constexpr double pi
Pi and functions thereof:
Definition Constants.h:363
casacore::min
LatticeExprNode min(const LatticeExprNode &left, const LatticeExprNode &right)
casacore::abs
LatticeExprNode abs(const LatticeExprNode &expr)
Numerical 1-argument functions which result in a real number regardless of input expression type.
casacore::ntrue
LatticeExprNode ntrue(const LatticeExprNode &expr)
casacore::cos
LatticeExprNode cos(const LatticeExprNode &expr)
casacore::True
const Bool True
Definition aipstype.h:41

In this rather silly example, we fill Lattice "f1" with the result of the expression. The expression shows the use of constants, unary operations, binary operations, 1D and 2D functions. It also shows how mixed types can be handled. The output Lattice is a Float, whereas mixed into the expression are subexpressions involving Float, Double, Complex and Bool Lattices.

### Motivation

The Lattice expression classes enable the C++ programmer much simpler handling of mathematical expressions involving lattices. In addition, these classes provide the infrastructure on top of which we can build an image calculator for Glish users

### To Do

- masks
- regions

Definition at line 140 of file LatticeExpr.h.

## Constructor & Destructor Documentation

## LatticeExpr() [1/4]

template<class T>

casacore::LatticeExpr< T >::LatticeExpr | ( |  | ) |

Default constructor.

Referenced by LatticeExpr(), and operator=().

## LatticeExpr() [2/4]

template<class T>

casacore::LatticeExpr< T >::LatticeExpr | ( | const LatticeExprNode & | expr | ) |

Constructor from an arbitrary LatticeExprNode expression object.

An exception is thrown if the expression data type cannot be converted to the template data type. The shape argument is mandatory if the expression has no shape. If the expression has a shape and if shape is given, it is checked if they are equal.

## LatticeExpr() [3/4]

template<class T>

casacore::LatticeExpr< T >::LatticeExpr | ( | const LatticeExprNode & | expr,
|  | const IPosition & | latticeShape )

## LatticeExpr() [4/4]

template<class T>

casacore::LatticeExpr< T >::LatticeExpr | ( | const LatticeExpr< T > & | other | ) |

Copy constructor (reference semantics).

References LatticeExpr().

## ~LatticeExpr()

template<class T>

virtual casacore::LatticeExpr< T >::~LatticeExpr | ( |  | ) |

virtual

Destructor, does nothing.

## Member Function Documentation

## cloneML()

template<class T>

virtual MaskedLattice< T > * casacore::LatticeExpr< T >::cloneML | ( |  | ) | const

virtual

Make a copy of the derived object (reference semantics).

Implements casacore::MaskedLattice< T >.

References casacore::MaskedLattice< T >::MaskedLattice().

## copyDataTo()

template<class T>

virtual void casacore::LatticeExpr< T >::copyDataTo | ( | Lattice< T > & | to | ) | const

virtual

Copy the data from this lattice to the given lattice.

Reimplemented from casacore::Lattice< T >.

## doGetMaskSlice()

template<class T>

virtual Bool casacore::LatticeExpr< T >::doGetMaskSlice | ( | Array< Bool > & | buffer,
|  | const Slicer & | section )

virtual

Do the actual get of the mask data.

The return value is always False, thus the buffer does not reference another array.

Reimplemented from casacore::MaskedLattice< T >.

## doGetSlice()

template<class T>

virtual Bool casacore::LatticeExpr< T >::doGetSlice | ( | Array< T > & | buffer,
|  | const Slicer & | section )

virtual

Do the actual get of the data.

The return value is always False, thus the buffer does not reference another array.

Implements casacore::Lattice< T >.

## doNiceCursorShape()

template<class T>

virtual IPosition casacore::LatticeExpr< T >::doNiceCursorShape | ( | uInt | maxPixels | ) | const

virtual

Return the best cursor shape.

Reimplemented from casacore::LatticeBase.

## doPutSlice()

template<class T>

virtual void casacore::LatticeExpr< T >::doPutSlice | ( | const Array< T > & | sourceBuffer,
|  | const IPosition & | where,
|  | const IPosition & | stride )

virtual

An expression is not writable so this functions throws an exception.

Implements casacore::Lattice< T >.

## getRegionPtr()

template<class T>

virtual const LatticeRegion * casacore::LatticeExpr< T >::getRegionPtr | ( |  | ) | const

virtual

Get the region used (always returns 0).

Implements casacore::MaskedLattice< T >.

## handleMathTo() [1/2]

void casacore::LatticeExpr< Bool >::handleMathTo | ( | Lattice< Bool > & | ,
|  | int | ) const

inline

Definition at line 243 of file LatticeExpr.h.

## handleMathTo() [2/2]

template<class T>

virtual void casacore::LatticeExpr< T >::handleMathTo | ( | Lattice< T > & | to,
|  | int | oper ) const

virtual

Handle the Math operators (+=, -=, *=, /=).

They work similarly to copyData(To). However, they are not defined for Bool types, thus specialized below.

Reimplemented from casacore::Lattice< T >.

## hasLock()

template<class T>

virtual Bool casacore::LatticeExpr< T >::hasLock | ( | FileLocker::LockType |  | ) | const

virtual

Reimplemented from casacore::LatticeBase.

## init()

template<class T>

void casacore::LatticeExpr< T >::init | ( | const LatticeExprNode & | expr | ) |

private

Initialize the object from the expression.

## isMasked()

template<class T>

virtual Bool casacore::LatticeExpr< T >::isMasked | ( |  | ) | const

virtual

Has the object really a mask?

Reimplemented from casacore::MaskedLattice< T >.

## isWritable()

template<class T>

virtual Bool casacore::LatticeExpr< T >::isWritable | ( |  | ) | const

virtual

Returns False, as the LatticeExpr lattice is not writable.

Reimplemented from casacore::LatticeBase.

## lelCoordinates()

template<class T>

virtual LELCoordinates casacore::LatticeExpr< T >::lelCoordinates | ( |  | ) | const

virtual

Returns the coordinates of the lattice expression.

Reimplemented from casacore::LatticeBase.

## lock()

template<class T>

virtual Bool casacore::LatticeExpr< T >::lock | ( | FileLocker::LockType | ,
|  | uInt | nattempts )

virtual

Handle locking of the LatticeExpr which is delegated to all of its parts.

hasLock() is True if all parts of the expression return True.
It is strongly recommended to use class LatticeLocker to handle lattice locking. It also contains a more detailed explanation of the locking process.

Reimplemented from casacore::LatticeBase.

## operator=()

template<class T>

LatticeExpr< T > & casacore::LatticeExpr< T >::operator= | ( | const LatticeExpr< T > & | other | ) |

Assignment (reference semantics).

References LatticeExpr().

## resync()

template<class T>

virtual void casacore::LatticeExpr< T >::resync | ( |  | ) |

virtual

Resynchronize the Lattice object with the lattice file.

This function is only useful if no read-locking is used, ie. if the table lock option is UserNoReadLocking or AutoNoReadLocking. In that cases the table system does not acquire a read-lock, thus does not synchronize itself automatically.
By default the function does not do anything at all.

Reimplemented from casacore::LatticeBase.

## shape()

template<class T>

virtual IPosition casacore::LatticeExpr< T >::shape | ( |  | ) | const

virtual

Returns the shape of the Lattice including all degenerate axes (i.e.

axes with a length of one)

Implements casacore::LatticeBase.

## unlock()

template<class T>

virtual void casacore::LatticeExpr< T >::unlock | ( |  | ) |

virtual

Reimplemented from casacore::LatticeBase.

## Member Data Documentation

## expr_p

template<class T>

LatticeExprNode casacore::LatticeExpr< T >::expr_p

private

Definition at line 235 of file LatticeExpr.h.

## lastChunkPtr_p

template<class T>

LELArray<T>* casacore::LatticeExpr< T >::lastChunkPtr_p

private

Definition at line 237 of file LatticeExpr.h.

## lastSlicer_p

template<class T>

Slicer casacore::LatticeExpr< T >::lastSlicer_p

private

Definition at line 238 of file LatticeExpr.h.

## shape_p

template<class T>

IPosition casacore::LatticeExpr< T >::shape_p

private

Definition at line 236 of file LatticeExpr.h.

The documentation for this class was generated from the following files:

- images/Regions/WCLELMask.h
- lattices/LEL/LatticeExpr.h